/*
 * controller.c
 *
 *  Created on: 07.12.2017
 *      Author: Rafa�
 */
#include "controller.h"

const int32_t MAX = 1000;
const int32_t MIN = 0;

int32_t pd(int32_t e, int32_t u_0, int32_t p, int32_t d){
	static int32_t e_k = 0;
	int32_t u = u_0 + (p*e + d*(e - e_k))/10000;
	e_k = e;
	if(u > MAX) u = MAX;
	else if(u < MIN) u = MIN;

	return u;
}

#ifndef TINYTEST_NOTESTING

int32_t test_pd(void)
{
    TINYTEST_EQUAL(0, pd(0, 0, 0, 0));

    return 1;
}

TINYTEST_START_SUITE(Controller);
  TINYTEST_ADD_TEST(test_pd,NULL,NULL);
TINYTEST_END_SUITE();

#endif

